CFB_CipherAbstractPolicy Class Referenceabstract

Policy object for feeback based stream ciphers. More...

Inheritance diagram for CFB_CipherAbstractPolicy:

## Public Member Functions

virtual unsigned int | GetAlignment () const =0
| Provides data alignment requirements. More...
virtual unsigned int | GetBytesPerIteration () const =0
| Provides number of bytes operated upon during an iteration. More...
virtual byte * | GetRegisterBegin ()=0
| Access the feedback register. More...
virtual void | TransformRegister ()=0
| TODO.
virtual bool | CanIterate () const
| Flag indicating iteration support. More...
virtual void | Iterate (byte *output, const byte *input, CipherDir dir, size_t iterationCount)
| Iterate the cipher. More...
virtual void | CipherSetKey (const NameValuePairs &params, const byte *key, size_t length)=0
| Key the cipher. More...
virtual void | CipherResynchronize (const byte *iv, size_t length)
| Resynchronize the cipher. More...

## Detailed Description

Policy object for feeback based stream ciphers.

Definition at line 350 of file strciphr.h.

## Member Function Documentation

## GetAlignment()

virtual unsigned int CFB_CipherAbstractPolicy::GetAlignment | ( |  | ) | const

pure virtual

Provides data alignment requirements.

Returns
  data alignment requirements, in bytes

Internally, the default implementation returns 1. If the stream cipher is implemented using an SSE2 ASM or intrinsics, then the value returned is usually 16.

## GetBytesPerIteration()

virtual unsigned int CFB_CipherAbstractPolicy::GetBytesPerIteration | ( |  | ) | const

pure virtual

Provides number of bytes operated upon during an iteration.

Returns
  bytes operated upon during an iteration, in bytes

See also
  GetOptimalBlockSize()

## GetRegisterBegin()

virtual byte* CFB_CipherAbstractPolicy::GetRegisterBegin | ( |  | ) |

pure virtual

Access the feedback register.

Returns
  pointer to the first byte of the feedback register

## CanIterate()

virtual bool CFB_CipherAbstractPolicy::CanIterate | ( |  | ) | const

inline virtual

Flag indicating iteration support.

Returns
  true if the cipher supports iteration, false otherwise

Definition at line 375 of file strciphr.h.

## Iterate()

virtual void CFB_CipherAbstractPolicy::Iterate | ( | byte * | output,
|  | const byte * | input,
|  | CipherDir | dir,
|  | size_t | iterationCount
| ) |  |

inline virtual

Iterate the cipher.

Parameters

  output | the output buffer
  input | the input buffer
  dir | the direction of the cipher
  iterationCount | the number of iterations to perform on the input

See also
  IsSelfInverting() and IsForwardTransformation()

Definition at line 383 of file strciphr.h.

## CipherSetKey()

virtual void CFB_CipherAbstractPolicy::CipherSetKey | ( | const NameValuePairs & | params,
|  | const byte * | key,
|  | size_t | length
| ) |  |

pure virtual

Key the cipher.

Parameters

  params | set of NameValuePairs use to initialize this object
  key | a byte array used to key the cipher
  length | the size of the key array

## CipherResynchronize()

virtual void CFB_CipherAbstractPolicy::CipherResynchronize | ( | const byte * | iv,
|  | size_t | length
| ) |  |

inline virtual

Resynchronize the cipher.

Parameters

  iv | a byte array used to resynchronize the cipher
  length | the size of the IV array

Definition at line 396 of file strciphr.h.

The documentation for this class was generated from the following file:

- strciphr.h